<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistributionlist ArrayType
 * @subpackage Arrays
 */
class ArrayOfDistributionlist extends AbstractStructArrayBase
{
    /**
     * The Distributionlist
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Distributionlist[]
     */
    public $Distributionlist;
    /**
     * Constructor method for ArrayOfDistributionlist
     * @uses ArrayOfDistributionlist::setDistributionlist()
     * @param \StructType\Distributionlist[] $distributionlist
     */
    public function __construct(array $distributionlist = array())
    {
        $this
            ->setDistributionlist($distributionlist);
    }
    /**
     * Get Distributionlist value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Distributionlist[]|null
     */
    public function getDistributionlist()
    {
        return isset($this->Distributionlist) ? $this->Distributionlist : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDistributionlist method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDistributionlist method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDistributionlistForArrayConstraintsFromSetDistributionlist(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDistributionlistDistributionlistItem) {
            // validation for constraint: itemType
            if (!$arrayOfDistributionlistDistributionlistItem instanceof \StructType\Distributionlist) {
                $invalidValues[] = is_object($arrayOfDistributionlistDistributionlistItem) ? get_class($arrayOfDistributionlistDistributionlistItem) : sprintf('%s(%s)', gettype($arrayOfDistributionlistDistributionlistItem), var_export($arrayOfDistributionlistDistributionlistItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Distributionlist property can only contain items of type \StructType\Distributionlist, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Distributionlist value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Distributionlist[] $distributionlist
     * @return \ArrayType\ArrayOfDistributionlist
     */
    public function setDistributionlist(array $distributionlist = array())
    {
        // validation for constraint: array
        if ('' !== ($distributionlistArrayErrorMessage = self::validateDistributionlistForArrayConstraintsFromSetDistributionlist($distributionlist))) {
            throw new \InvalidArgumentException($distributionlistArrayErrorMessage, __LINE__);
        }
        if (is_null($distributionlist) || (is_array($distributionlist) && empty($distributionlist))) {
            unset($this->Distributionlist);
        } else {
            $this->Distributionlist = $distributionlist;
        }
        return $this;
    }
    /**
     * Add item to Distributionlist value
     * @throws \InvalidArgumentException
     * @param \StructType\Distributionlist $item
     * @return \ArrayType\ArrayOfDistributionlist
     */
    public function addToDistributionlist(\StructType\Distributionlist $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Distributionlist) {
            throw new \InvalidArgumentException(sprintf('The Distributionlist property can only contain items of type \StructType\Distributionlist, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Distributionlist[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Distributionlist|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Distributionlist|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Distributionlist|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Distributionlist|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Distributionlist|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Distributionlist
     */
    public function getAttributeName()
    {
        return 'Distributionlist';
    }
}
