<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentTypeProfileValuePrinter ArrayType
 * @subpackage Arrays
 */
class ArrayOfDocumentTypeProfileValuePrinter extends AbstractStructArrayBase
{
    /**
     * The DocumentTypeProfileValuePrinter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentTypeProfileValuePrinter[]
     */
    public $DocumentTypeProfileValuePrinter;
    /**
     * Constructor method for ArrayOfDocumentTypeProfileValuePrinter
     * @uses ArrayOfDocumentTypeProfileValuePrinter::setDocumentTypeProfileValuePrinter()
     * @param \StructType\DocumentTypeProfileValuePrinter[] $documentTypeProfileValuePrinter
     */
    public function __construct(array $documentTypeProfileValuePrinter = array())
    {
        $this
            ->setDocumentTypeProfileValuePrinter($documentTypeProfileValuePrinter);
    }
    /**
     * Get DocumentTypeProfileValuePrinter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentTypeProfileValuePrinter[]|null
     */
    public function getDocumentTypeProfileValuePrinter()
    {
        return isset($this->DocumentTypeProfileValuePrinter) ? $this->DocumentTypeProfileValuePrinter : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDocumentTypeProfileValuePrinter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocumentTypeProfileValuePrinter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentTypeProfileValuePrinterForArrayConstraintsFromSetDocumentTypeProfileValuePrinter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDocumentTypeProfileValuePrinterDocumentTypeProfileValuePrinterItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentTypeProfileValuePrinterDocumentTypeProfileValuePrinterItem instanceof \StructType\DocumentTypeProfileValuePrinter) {
                $invalidValues[] = is_object($arrayOfDocumentTypeProfileValuePrinterDocumentTypeProfileValuePrinterItem) ? get_class($arrayOfDocumentTypeProfileValuePrinterDocumentTypeProfileValuePrinterItem) : sprintf('%s(%s)', gettype($arrayOfDocumentTypeProfileValuePrinterDocumentTypeProfileValuePrinterItem), var_export($arrayOfDocumentTypeProfileValuePrinterDocumentTypeProfileValuePrinterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DocumentTypeProfileValuePrinter property can only contain items of type \StructType\DocumentTypeProfileValuePrinter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DocumentTypeProfileValuePrinter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentTypeProfileValuePrinter[] $documentTypeProfileValuePrinter
     * @return \ArrayType\ArrayOfDocumentTypeProfileValuePrinter
     */
    public function setDocumentTypeProfileValuePrinter(array $documentTypeProfileValuePrinter = array())
    {
        // validation for constraint: array
        if ('' !== ($documentTypeProfileValuePrinterArrayErrorMessage = self::validateDocumentTypeProfileValuePrinterForArrayConstraintsFromSetDocumentTypeProfileValuePrinter($documentTypeProfileValuePrinter))) {
            throw new \InvalidArgumentException($documentTypeProfileValuePrinterArrayErrorMessage, __LINE__);
        }
        if (is_null($documentTypeProfileValuePrinter) || (is_array($documentTypeProfileValuePrinter) && empty($documentTypeProfileValuePrinter))) {
            unset($this->DocumentTypeProfileValuePrinter);
        } else {
            $this->DocumentTypeProfileValuePrinter = $documentTypeProfileValuePrinter;
        }
        return $this;
    }
    /**
     * Add item to DocumentTypeProfileValuePrinter value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentTypeProfileValuePrinter $item
     * @return \ArrayType\ArrayOfDocumentTypeProfileValuePrinter
     */
    public function addToDocumentTypeProfileValuePrinter(\StructType\DocumentTypeProfileValuePrinter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentTypeProfileValuePrinter) {
            throw new \InvalidArgumentException(sprintf('The DocumentTypeProfileValuePrinter property can only contain items of type \StructType\DocumentTypeProfileValuePrinter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DocumentTypeProfileValuePrinter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentTypeProfileValuePrinter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentTypeProfileValuePrinter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentTypeProfileValuePrinter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentTypeProfileValuePrinter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentTypeProfileValuePrinter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentTypeProfileValuePrinter
     */
    public function getAttributeName()
    {
        return 'DocumentTypeProfileValuePrinter';
    }
}
