<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDynamicWorkFlow ArrayType
 * @subpackage Arrays
 */
class ArrayOfDynamicWorkFlow extends AbstractStructArrayBase
{
    /**
     * The DynamicWorkFlow
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DynamicWorkFlow[]
     */
    public $DynamicWorkFlow;
    /**
     * Constructor method for ArrayOfDynamicWorkFlow
     * @uses ArrayOfDynamicWorkFlow::setDynamicWorkFlow()
     * @param \StructType\DynamicWorkFlow[] $dynamicWorkFlow
     */
    public function __construct(array $dynamicWorkFlow = array())
    {
        $this
            ->setDynamicWorkFlow($dynamicWorkFlow);
    }
    /**
     * Get DynamicWorkFlow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DynamicWorkFlow[]|null
     */
    public function getDynamicWorkFlow()
    {
        return isset($this->DynamicWorkFlow) ? $this->DynamicWorkFlow : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDynamicWorkFlow method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDynamicWorkFlow method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDynamicWorkFlowForArrayConstraintsFromSetDynamicWorkFlow(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDynamicWorkFlowDynamicWorkFlowItem) {
            // validation for constraint: itemType
            if (!$arrayOfDynamicWorkFlowDynamicWorkFlowItem instanceof \StructType\DynamicWorkFlow) {
                $invalidValues[] = is_object($arrayOfDynamicWorkFlowDynamicWorkFlowItem) ? get_class($arrayOfDynamicWorkFlowDynamicWorkFlowItem) : sprintf('%s(%s)', gettype($arrayOfDynamicWorkFlowDynamicWorkFlowItem), var_export($arrayOfDynamicWorkFlowDynamicWorkFlowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DynamicWorkFlow property can only contain items of type \StructType\DynamicWorkFlow, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DynamicWorkFlow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DynamicWorkFlow[] $dynamicWorkFlow
     * @return \ArrayType\ArrayOfDynamicWorkFlow
     */
    public function setDynamicWorkFlow(array $dynamicWorkFlow = array())
    {
        // validation for constraint: array
        if ('' !== ($dynamicWorkFlowArrayErrorMessage = self::validateDynamicWorkFlowForArrayConstraintsFromSetDynamicWorkFlow($dynamicWorkFlow))) {
            throw new \InvalidArgumentException($dynamicWorkFlowArrayErrorMessage, __LINE__);
        }
        if (is_null($dynamicWorkFlow) || (is_array($dynamicWorkFlow) && empty($dynamicWorkFlow))) {
            unset($this->DynamicWorkFlow);
        } else {
            $this->DynamicWorkFlow = $dynamicWorkFlow;
        }
        return $this;
    }
    /**
     * Add item to DynamicWorkFlow value
     * @throws \InvalidArgumentException
     * @param \StructType\DynamicWorkFlow $item
     * @return \ArrayType\ArrayOfDynamicWorkFlow
     */
    public function addToDynamicWorkFlow(\StructType\DynamicWorkFlow $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DynamicWorkFlow) {
            throw new \InvalidArgumentException(sprintf('The DynamicWorkFlow property can only contain items of type \StructType\DynamicWorkFlow, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DynamicWorkFlow[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DynamicWorkFlow|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DynamicWorkFlow|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DynamicWorkFlow|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DynamicWorkFlow|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DynamicWorkFlow|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DynamicWorkFlow
     */
    public function getAttributeName()
    {
        return 'DynamicWorkFlow';
    }
}
