<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJMOLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfJMOLog extends AbstractStructArrayBase
{
    /**
     * The JMOLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\JMOLog[]
     */
    public $JMOLog;
    /**
     * Constructor method for ArrayOfJMOLog
     * @uses ArrayOfJMOLog::setJMOLog()
     * @param \StructType\JMOLog[] $jMOLog
     */
    public function __construct(array $jMOLog = array())
    {
        $this
            ->setJMOLog($jMOLog);
    }
    /**
     * Get JMOLog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\JMOLog[]|null
     */
    public function getJMOLog()
    {
        return isset($this->JMOLog) ? $this->JMOLog : null;
    }
    /**
     * This method is responsible for validating the values passed to the setJMOLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJMOLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJMOLogForArrayConstraintsFromSetJMOLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJMOLogJMOLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfJMOLogJMOLogItem instanceof \StructType\JMOLog) {
                $invalidValues[] = is_object($arrayOfJMOLogJMOLogItem) ? get_class($arrayOfJMOLogJMOLogItem) : sprintf('%s(%s)', gettype($arrayOfJMOLogJMOLogItem), var_export($arrayOfJMOLogJMOLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The JMOLog property can only contain items of type \StructType\JMOLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set JMOLog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\JMOLog[] $jMOLog
     * @return \ArrayType\ArrayOfJMOLog
     */
    public function setJMOLog(array $jMOLog = array())
    {
        // validation for constraint: array
        if ('' !== ($jMOLogArrayErrorMessage = self::validateJMOLogForArrayConstraintsFromSetJMOLog($jMOLog))) {
            throw new \InvalidArgumentException($jMOLogArrayErrorMessage, __LINE__);
        }
        if (is_null($jMOLog) || (is_array($jMOLog) && empty($jMOLog))) {
            unset($this->JMOLog);
        } else {
            $this->JMOLog = $jMOLog;
        }
        return $this;
    }
    /**
     * Add item to JMOLog value
     * @throws \InvalidArgumentException
     * @param \StructType\JMOLog $item
     * @return \ArrayType\ArrayOfJMOLog
     */
    public function addToJMOLog(\StructType\JMOLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JMOLog) {
            throw new \InvalidArgumentException(sprintf('The JMOLog property can only contain items of type \StructType\JMOLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->JMOLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JMOLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JMOLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JMOLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JMOLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JMOLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JMOLog
     */
    public function getAttributeName()
    {
        return 'JMOLog';
    }
}
