<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSecurityLevelShortInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfSecurityLevelShortInfo extends AbstractStructArrayBase
{
    /**
     * The SecurityLevelShortInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecurityLevelShortInfo[]
     */
    public $SecurityLevelShortInfo;
    /**
     * Constructor method for ArrayOfSecurityLevelShortInfo
     * @uses ArrayOfSecurityLevelShortInfo::setSecurityLevelShortInfo()
     * @param \StructType\SecurityLevelShortInfo[] $securityLevelShortInfo
     */
    public function __construct(array $securityLevelShortInfo = array())
    {
        $this
            ->setSecurityLevelShortInfo($securityLevelShortInfo);
    }
    /**
     * Get SecurityLevelShortInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecurityLevelShortInfo[]|null
     */
    public function getSecurityLevelShortInfo()
    {
        return isset($this->SecurityLevelShortInfo) ? $this->SecurityLevelShortInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSecurityLevelShortInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSecurityLevelShortInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSecurityLevelShortInfoForArrayConstraintsFromSetSecurityLevelShortInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSecurityLevelShortInfoSecurityLevelShortInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfSecurityLevelShortInfoSecurityLevelShortInfoItem instanceof \StructType\SecurityLevelShortInfo) {
                $invalidValues[] = is_object($arrayOfSecurityLevelShortInfoSecurityLevelShortInfoItem) ? get_class($arrayOfSecurityLevelShortInfoSecurityLevelShortInfoItem) : sprintf('%s(%s)', gettype($arrayOfSecurityLevelShortInfoSecurityLevelShortInfoItem), var_export($arrayOfSecurityLevelShortInfoSecurityLevelShortInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SecurityLevelShortInfo property can only contain items of type \StructType\SecurityLevelShortInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SecurityLevelShortInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SecurityLevelShortInfo[] $securityLevelShortInfo
     * @return \ArrayType\ArrayOfSecurityLevelShortInfo
     */
    public function setSecurityLevelShortInfo(array $securityLevelShortInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($securityLevelShortInfoArrayErrorMessage = self::validateSecurityLevelShortInfoForArrayConstraintsFromSetSecurityLevelShortInfo($securityLevelShortInfo))) {
            throw new \InvalidArgumentException($securityLevelShortInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($securityLevelShortInfo) || (is_array($securityLevelShortInfo) && empty($securityLevelShortInfo))) {
            unset($this->SecurityLevelShortInfo);
        } else {
            $this->SecurityLevelShortInfo = $securityLevelShortInfo;
        }
        return $this;
    }
    /**
     * Add item to SecurityLevelShortInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\SecurityLevelShortInfo $item
     * @return \ArrayType\ArrayOfSecurityLevelShortInfo
     */
    public function addToSecurityLevelShortInfo(\StructType\SecurityLevelShortInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SecurityLevelShortInfo) {
            throw new \InvalidArgumentException(sprintf('The SecurityLevelShortInfo property can only contain items of type \StructType\SecurityLevelShortInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SecurityLevelShortInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SecurityLevelShortInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SecurityLevelShortInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SecurityLevelShortInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SecurityLevelShortInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SecurityLevelShortInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SecurityLevelShortInfo
     */
    public function getAttributeName()
    {
        return 'SecurityLevelShortInfo';
    }
}
