<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GiveDocumentTypes' => '\\StructType\\GiveDocumentTypes',
            'GiveDocumentTypesResponse' => '\\StructType\\GiveDocumentTypesResponse',
            'ArrayOfSimpleObject' => '\\ArrayType\\ArrayOfSimpleObject',
            'SimpleObject' => '\\StructType\\SimpleObject',
            'AuthCredential' => '\\StructType\\AuthCredential',
            'GiveWorkflowList' => '\\StructType\\GiveWorkflowList',
            'GiveWorkflowListResponse' => '\\StructType\\GiveWorkflowListResponse',
            'TestAddDocument' => '\\StructType\\TestAddDocument',
            'TestAddDocumentResponse' => '\\StructType\\TestAddDocumentResponse',
            'EbysEvrakIndir' => '\\StructType\\EbysEvrakIndir',
            'EbysEvrakIndirResponse' => '\\StructType\\EbysEvrakIndirResponse',
            'EbysBelgeOlustur' => '\\StructType\\EbysBelgeOlustur',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'EbysBelgeOlusturResponse' => '\\StructType\\EbysBelgeOlusturResponse',
            'EbysBelgeSorgula' => '\\StructType\\EbysBelgeSorgula',
            'EbysBelgeSorgulaResponse' => '\\StructType\\EbysBelgeSorgulaResponse',
            'OranEvrakSorgula' => '\\StructType\\OranEvrakSorgula',
            'ArrayOfOranDocument' => '\\ArrayType\\ArrayOfOranDocument',
            'OranDocument' => '\\StructType\\OranDocument',
            'OranEvrakSorgulaResponse' => '\\StructType\\OranEvrakSorgulaResponse',
            'JMOBISEvrakLogSorgula' => '\\StructType\\JMOBISEvrakLogSorgula',
            'ArrayOfJMOLog' => '\\ArrayType\\ArrayOfJMOLog',
            'JMOLog' => '\\StructType\\JMOLog',
            'JMOBISEvrakLogSorgulaResponse' => '\\StructType\\JMOBISEvrakLogSorgulaResponse',
            'JMOBISEvrakSorgula' => '\\StructType\\JMOBISEvrakSorgula',
            'ArrayOfJMODocument' => '\\ArrayType\\ArrayOfJMODocument',
            'JMODocument' => '\\StructType\\JMODocument',
            'JMOBISEvrakSorgulaResponse' => '\\StructType\\JMOBISEvrakSorgulaResponse',
            'JMOBISToEbysBelgeSorgula' => '\\StructType\\JMOBISToEbysBelgeSorgula',
            'JMOBISToEbysBelgeSorgulaResponse' => '\\StructType\\JMOBISToEbysBelgeSorgulaResponse',
            'JMOBISToEbysBelgeOlustur' => '\\StructType\\JMOBISToEbysBelgeOlustur',
            'JMOBISToEbysBelgeOlusturResponse' => '\\StructType\\JMOBISToEbysBelgeOlusturResponse',
            'DEUToEbysBelgeOlustur' => '\\StructType\\DEUToEbysBelgeOlustur',
            'DEUToEbysBelgeOlusturResponse' => '\\StructType\\DEUToEbysBelgeOlusturResponse',
            'DEUToEbysBelgeSorgula' => '\\StructType\\DEUToEbysBelgeSorgula',
            'DEUToEbysBelgeSorgulaResponse' => '\\StructType\\DEUToEbysBelgeSorgulaResponse',
            'ObsToEbysBelgeOlustur' => '\\StructType\\ObsToEbysBelgeOlustur',
            'ObsToEbysBelgeOlusturResponse' => '\\StructType\\ObsToEbysBelgeOlusturResponse',
            'ObsToEbysBelgeSorgula' => '\\StructType\\ObsToEbysBelgeSorgula',
            'ObsToEbysBelgeSorgulaResponse' => '\\StructType\\ObsToEbysBelgeSorgulaResponse',
            'AddDocument' => '\\StructType\\AddDocument',
            'SimpleDocument' => '\\StructType\\SimpleDocument',
            'AddDocumentResponse' => '\\StructType\\AddDocumentResponse',
            'GetChairsForUser' => '\\StructType\\GetChairsForUser',
            'GetChairsForUserResponse' => '\\StructType\\GetChairsForUserResponse',
            'GetUsers' => '\\StructType\\GetUsers',
            'GetUsersResponse' => '\\StructType\\GetUsersResponse',
            'ViewDocument' => '\\StructType\\ViewDocument',
            'ViewDocumentResponse' => '\\StructType\\ViewDocumentResponse',
            'GetUnReadDocuments' => '\\StructType\\GetUnReadDocuments',
            'GetUnReadDocumentsResponse' => '\\StructType\\GetUnReadDocumentsResponse',
            'ArrayOfUnreadDocument' => '\\ArrayType\\ArrayOfUnreadDocument',
            'UnreadDocument' => '\\StructType\\UnreadDocument',
            'GetSignDocuments' => '\\StructType\\GetSignDocuments',
            'GetSignDocumentsResponse' => '\\StructType\\GetSignDocumentsResponse',
            'ArrayOfSignDocument' => '\\ArrayType\\ArrayOfSignDocument',
            'SignDocument' => '\\StructType\\SignDocument',
            'GetServiceAndProfileValue' => '\\StructType\\GetServiceAndProfileValue',
            'GetServiceAndProfileValueResponse' => '\\StructType\\GetServiceAndProfileValueResponse',
            'ArrayOfServiceObject' => '\\ArrayType\\ArrayOfServiceObject',
            'ServiceObject' => '\\StructType\\ServiceObject',
            'SearchChairPrinter' => '\\StructType\\SearchChairPrinter',
            'SearchChairPrinterResponse' => '\\StructType\\SearchChairPrinterResponse',
            'SaveDynamicWorkFlow' => '\\StructType\\SaveDynamicWorkFlow',
            'ArrayOfDynamicWorkFlow' => '\\ArrayType\\ArrayOfDynamicWorkFlow',
            'DynamicWorkFlow' => '\\StructType\\DynamicWorkFlow',
            'SaveDynamicWorkFlowResponse' => '\\StructType\\SaveDynamicWorkFlowResponse',
            'GetWebServiceInfo' => '\\StructType\\GetWebServiceInfo',
            'GetWebServiceInfoResponse' => '\\StructType\\GetWebServiceInfoResponse',
            'WebServiceInfo' => '\\StructType\\WebServiceInfo',
            'getDocumentTypeProfileValuesEC' => '\\StructType\\GetDocumentTypeProfileValuesEC',
            'getDocumentTypeProfileValuesECResponse' => '\\StructType\\GetDocumentTypeProfileValuesECResponse',
            'ArrayOfDocumentTypeProfileValue' => '\\ArrayType\\ArrayOfDocumentTypeProfileValue',
            'DocumentTypeProfileValue' => '\\StructType\\DocumentTypeProfileValue',
            'getDocumentTypeProfileValuesPrinter' => '\\StructType\\GetDocumentTypeProfileValuesPrinter',
            'getDocumentTypeProfileValuesPrinterResponse' => '\\StructType\\GetDocumentTypeProfileValuesPrinterResponse',
            'ArrayOfDocumentTypeProfileValuePrinter' => '\\ArrayType\\ArrayOfDocumentTypeProfileValuePrinter',
            'DocumentTypeProfileValuePrinter' => '\\StructType\\DocumentTypeProfileValuePrinter',
            'saveDocumentTypeProfileValues' => '\\StructType\\SaveDocumentTypeProfileValues',
            'saveDocumentTypeProfileValuesResponse' => '\\StructType\\SaveDocumentTypeProfileValuesResponse',
            'saveDocumentTypeProfileValuesPrinter' => '\\StructType\\SaveDocumentTypeProfileValuesPrinter',
            'saveDocumentTypeProfileValuesPrinterResponse' => '\\StructType\\SaveDocumentTypeProfileValuesPrinterResponse',
            'getChairID' => '\\StructType\\GetChairID',
            'getChairIDResponse' => '\\StructType\\GetChairIDResponse',
            'GetUsersChairs' => '\\StructType\\GetUsersChairs',
            'GetUsersChairsResponse' => '\\StructType\\GetUsersChairsResponse',
            'GetServiceUserInfoGS' => '\\StructType\\GetServiceUserInfoGS',
            'GetServiceUserInfoGSResponse' => '\\StructType\\GetServiceUserInfoGSResponse',
            'ArrayOfServiceUserInfo' => '\\ArrayType\\ArrayOfServiceUserInfo',
            'ServiceUserInfo' => '\\StructType\\ServiceUserInfo',
            'SaveDynamicWorkFlowGS' => '\\StructType\\SaveDynamicWorkFlowGS',
            'SaveDynamicWorkFlowGSResponse' => '\\StructType\\SaveDynamicWorkFlowGSResponse',
            'ViewDocumentGS' => '\\StructType\\ViewDocumentGS',
            'ViewDocumentGSResponse' => '\\StructType\\ViewDocumentGSResponse',
            'GetDocumentProcessInfoGS' => '\\StructType\\GetDocumentProcessInfoGS',
            'GetDocumentProcessInfoGSResponse' => '\\StructType\\GetDocumentProcessInfoGSResponse',
            'GetSDPlist' => '\\StructType\\GetSDPlist',
            'GetSDPlistResponse' => '\\StructType\\GetSDPlistResponse',
            'GetPersonelInfoforIncomingGS' => '\\StructType\\GetPersonelInfoforIncomingGS',
            'GetPersonelInfoforIncomingGSResponse' => '\\StructType\\GetPersonelInfoforIncomingGSResponse',
            'ArrayOfDTVTUnit' => '\\ArrayType\\ArrayOfDTVTUnit',
            'DTVTUnit' => '\\StructType\\DTVTUnit',
            'AddDtvtGS' => '\\StructType\\AddDtvtGS',
            'DTVTClasses' => '\\StructType\\DTVTClasses',
            'AddDtvtGSResponse' => '\\StructType\\AddDtvtGSResponse',
            'KeyValue' => '\\StructType\\KeyValue',
            'PostDocumentDataGS' => '\\StructType\\PostDocumentDataGS',
            'PostDocumentDataGSResponse' => '\\StructType\\PostDocumentDataGSResponse',
            'LoadEmptyObjectGS' => '\\StructType\\LoadEmptyObjectGS',
            'LoadEmptyObjectGSResponse' => '\\StructType\\LoadEmptyObjectGSResponse',
            'Document' => '\\StructType\\Document',
            'SystemProperty' => '\\StructType\\SystemProperty',
            'ArrayOfAppendix' => '\\ArrayType\\ArrayOfAppendix',
            'Appendix' => '\\StructType\\Appendix',
            'ArrayOfDistributionlist' => '\\ArrayType\\ArrayOfDistributionlist',
            'Distributionlist' => '\\StructType\\Distributionlist',
            'ArrayOfArchiveStore' => '\\ArrayType\\ArrayOfArchiveStore',
            'ArchiveStore' => '\\StructType\\ArchiveStore',
            'ArrayOfSecurityLevelShortInfo' => '\\ArrayType\\ArrayOfSecurityLevelShortInfo',
            'SecurityLevelShortInfo' => '\\StructType\\SecurityLevelShortInfo',
            'ScannedImageProperties' => '\\StructType\\ScannedImageProperties',
            'SaveObjectGS' => '\\StructType\\SaveObjectGS',
            'SaveObjectGSResponse' => '\\StructType\\SaveObjectGSResponse',
        );
    }
}
