<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddDtvtGS StructType
 * @subpackage Structs
 */
class AddDtvtGS extends AbstractStructBase
{
    /**
     * The dtvtObject
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DTVTClasses
     */
    public $dtvtObject;
    /**
     * The control
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $control;
    /**
     * The commonName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $commonName;
    /**
     * The modeTypeDTVT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $modeTypeDTVT;
    /**
     * Constructor method for AddDtvtGS
     * @uses AddDtvtGS::setDtvtObject()
     * @uses AddDtvtGS::setControl()
     * @uses AddDtvtGS::setCommonName()
     * @uses AddDtvtGS::setModeTypeDTVT()
     * @param \StructType\DTVTClasses $dtvtObject
     * @param string $control
     * @param string $commonName
     * @param string $modeTypeDTVT
     */
    public function __construct(\StructType\DTVTClasses $dtvtObject = null, $control = null, $commonName = null, $modeTypeDTVT = null)
    {
        $this
            ->setDtvtObject($dtvtObject)
            ->setControl($control)
            ->setCommonName($commonName)
            ->setModeTypeDTVT($modeTypeDTVT);
    }
    /**
     * Get dtvtObject value
     * @return \StructType\DTVTClasses|null
     */
    public function getDtvtObject()
    {
        return $this->dtvtObject;
    }
    /**
     * Set dtvtObject value
     * @param \StructType\DTVTClasses $dtvtObject
     * @return \StructType\AddDtvtGS
     */
    public function setDtvtObject(\StructType\DTVTClasses $dtvtObject = null)
    {
        $this->dtvtObject = $dtvtObject;
        return $this;
    }
    /**
     * Get control value
     * @return string|null
     */
    public function getControl()
    {
        return $this->control;
    }
    /**
     * Set control value
     * @param string $control
     * @return \StructType\AddDtvtGS
     */
    public function setControl($control = null)
    {
        // validation for constraint: string
        if (!is_null($control) && !is_string($control)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($control, true), gettype($control)), __LINE__);
        }
        $this->control = $control;
        return $this;
    }
    /**
     * Get commonName value
     * @return string|null
     */
    public function getCommonName()
    {
        return $this->commonName;
    }
    /**
     * Set commonName value
     * @param string $commonName
     * @return \StructType\AddDtvtGS
     */
    public function setCommonName($commonName = null)
    {
        // validation for constraint: string
        if (!is_null($commonName) && !is_string($commonName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commonName, true), gettype($commonName)), __LINE__);
        }
        $this->commonName = $commonName;
        return $this;
    }
    /**
     * Get modeTypeDTVT value
     * @return string|null
     */
    public function getModeTypeDTVT()
    {
        return $this->modeTypeDTVT;
    }
    /**
     * Set modeTypeDTVT value
     * @param string $modeTypeDTVT
     * @return \StructType\AddDtvtGS
     */
    public function setModeTypeDTVT($modeTypeDTVT = null)
    {
        // validation for constraint: string
        if (!is_null($modeTypeDTVT) && !is_string($modeTypeDTVT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modeTypeDTVT, true), gettype($modeTypeDTVT)), __LINE__);
        }
        $this->modeTypeDTVT = $modeTypeDTVT;
        return $this;
    }
}
