<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Distributionlist StructType
 * @subpackage Structs
 */
class Distributionlist extends AbstractStructBase
{
    /**
     * The ObjectID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ObjectID;
    /**
     * The DocumentObjectID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $DocumentObjectID;
    /**
     * The UserID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $UserID;
    /**
     * The VekilID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $VekilID;
    /**
     * The SendLocationId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SendLocationId;
    /**
     * The IsDtvt
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsDtvt;
    /**
     * The DistributionType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $DistributionType;
    /**
     * The DontSend
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $DontSend;
    /**
     * The DistributionName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistributionName;
    /**
     * The CreatedDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CreatedDate;
    /**
     * The CreatedTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CreatedTime;
    /**
     * The SendLocationType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SendLocationType;
    /**
     * The Note
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Note;
    /**
     * The KepOrMailAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KepOrMailAddress;
    /**
     * The OutGoType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OutGoType;
    /**
     * Constructor method for Distributionlist
     * @uses Distributionlist::setObjectID()
     * @uses Distributionlist::setDocumentObjectID()
     * @uses Distributionlist::setUserID()
     * @uses Distributionlist::setVekilID()
     * @uses Distributionlist::setSendLocationId()
     * @uses Distributionlist::setIsDtvt()
     * @uses Distributionlist::setDistributionType()
     * @uses Distributionlist::setDontSend()
     * @uses Distributionlist::setDistributionName()
     * @uses Distributionlist::setCreatedDate()
     * @uses Distributionlist::setCreatedTime()
     * @uses Distributionlist::setSendLocationType()
     * @uses Distributionlist::setNote()
     * @uses Distributionlist::setKepOrMailAddress()
     * @uses Distributionlist::setOutGoType()
     * @param int $objectID
     * @param int $documentObjectID
     * @param int $userID
     * @param int $vekilID
     * @param int $sendLocationId
     * @param bool $isDtvt
     * @param bool $distributionType
     * @param bool $dontSend
     * @param string $distributionName
     * @param string $createdDate
     * @param string $createdTime
     * @param string $sendLocationType
     * @param string $note
     * @param string $kepOrMailAddress
     * @param string $outGoType
     */
    public function __construct($objectID = null, $documentObjectID = null, $userID = null, $vekilID = null, $sendLocationId = null, $isDtvt = null, $distributionType = null, $dontSend = null, $distributionName = null, $createdDate = null, $createdTime = null, $sendLocationType = null, $note = null, $kepOrMailAddress = null, $outGoType = null)
    {
        $this
            ->setObjectID($objectID)
            ->setDocumentObjectID($documentObjectID)
            ->setUserID($userID)
            ->setVekilID($vekilID)
            ->setSendLocationId($sendLocationId)
            ->setIsDtvt($isDtvt)
            ->setDistributionType($distributionType)
            ->setDontSend($dontSend)
            ->setDistributionName($distributionName)
            ->setCreatedDate($createdDate)
            ->setCreatedTime($createdTime)
            ->setSendLocationType($sendLocationType)
            ->setNote($note)
            ->setKepOrMailAddress($kepOrMailAddress)
            ->setOutGoType($outGoType);
    }
    /**
     * Get ObjectID value
     * @return int
     */
    public function getObjectID()
    {
        return $this->ObjectID;
    }
    /**
     * Set ObjectID value
     * @param int $objectID
     * @return \StructType\Distributionlist
     */
    public function setObjectID($objectID = null)
    {
        // validation for constraint: int
        if (!is_null($objectID) && !(is_int($objectID) || ctype_digit($objectID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($objectID, true), gettype($objectID)), __LINE__);
        }
        $this->ObjectID = $objectID;
        return $this;
    }
    /**
     * Get DocumentObjectID value
     * @return int
     */
    public function getDocumentObjectID()
    {
        return $this->DocumentObjectID;
    }
    /**
     * Set DocumentObjectID value
     * @param int $documentObjectID
     * @return \StructType\Distributionlist
     */
    public function setDocumentObjectID($documentObjectID = null)
    {
        // validation for constraint: int
        if (!is_null($documentObjectID) && !(is_int($documentObjectID) || ctype_digit($documentObjectID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($documentObjectID, true), gettype($documentObjectID)), __LINE__);
        }
        $this->DocumentObjectID = $documentObjectID;
        return $this;
    }
    /**
     * Get UserID value
     * @return int
     */
    public function getUserID()
    {
        return $this->UserID;
    }
    /**
     * Set UserID value
     * @param int $userID
     * @return \StructType\Distributionlist
     */
    public function setUserID($userID = null)
    {
        // validation for constraint: int
        if (!is_null($userID) && !(is_int($userID) || ctype_digit($userID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($userID, true), gettype($userID)), __LINE__);
        }
        $this->UserID = $userID;
        return $this;
    }
    /**
     * Get VekilID value
     * @return int
     */
    public function getVekilID()
    {
        return $this->VekilID;
    }
    /**
     * Set VekilID value
     * @param int $vekilID
     * @return \StructType\Distributionlist
     */
    public function setVekilID($vekilID = null)
    {
        // validation for constraint: int
        if (!is_null($vekilID) && !(is_int($vekilID) || ctype_digit($vekilID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($vekilID, true), gettype($vekilID)), __LINE__);
        }
        $this->VekilID = $vekilID;
        return $this;
    }
    /**
     * Get SendLocationId value
     * @return int
     */
    public function getSendLocationId()
    {
        return $this->SendLocationId;
    }
    /**
     * Set SendLocationId value
     * @param int $sendLocationId
     * @return \StructType\Distributionlist
     */
    public function setSendLocationId($sendLocationId = null)
    {
        // validation for constraint: int
        if (!is_null($sendLocationId) && !(is_int($sendLocationId) || ctype_digit($sendLocationId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sendLocationId, true), gettype($sendLocationId)), __LINE__);
        }
        $this->SendLocationId = $sendLocationId;
        return $this;
    }
    /**
     * Get IsDtvt value
     * @return bool
     */
    public function getIsDtvt()
    {
        return $this->IsDtvt;
    }
    /**
     * Set IsDtvt value
     * @param bool $isDtvt
     * @return \StructType\Distributionlist
     */
    public function setIsDtvt($isDtvt = null)
    {
        // validation for constraint: boolean
        if (!is_null($isDtvt) && !is_bool($isDtvt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isDtvt, true), gettype($isDtvt)), __LINE__);
        }
        $this->IsDtvt = $isDtvt;
        return $this;
    }
    /**
     * Get DistributionType value
     * @return bool
     */
    public function getDistributionType()
    {
        return $this->DistributionType;
    }
    /**
     * Set DistributionType value
     * @param bool $distributionType
     * @return \StructType\Distributionlist
     */
    public function setDistributionType($distributionType = null)
    {
        // validation for constraint: boolean
        if (!is_null($distributionType) && !is_bool($distributionType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($distributionType, true), gettype($distributionType)), __LINE__);
        }
        $this->DistributionType = $distributionType;
        return $this;
    }
    /**
     * Get DontSend value
     * @return bool
     */
    public function getDontSend()
    {
        return $this->DontSend;
    }
    /**
     * Set DontSend value
     * @param bool $dontSend
     * @return \StructType\Distributionlist
     */
    public function setDontSend($dontSend = null)
    {
        // validation for constraint: boolean
        if (!is_null($dontSend) && !is_bool($dontSend)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($dontSend, true), gettype($dontSend)), __LINE__);
        }
        $this->DontSend = $dontSend;
        return $this;
    }
    /**
     * Get DistributionName value
     * @return string|null
     */
    public function getDistributionName()
    {
        return $this->DistributionName;
    }
    /**
     * Set DistributionName value
     * @param string $distributionName
     * @return \StructType\Distributionlist
     */
    public function setDistributionName($distributionName = null)
    {
        // validation for constraint: string
        if (!is_null($distributionName) && !is_string($distributionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distributionName, true), gettype($distributionName)), __LINE__);
        }
        $this->DistributionName = $distributionName;
        return $this;
    }
    /**
     * Get CreatedDate value
     * @return string|null
     */
    public function getCreatedDate()
    {
        return $this->CreatedDate;
    }
    /**
     * Set CreatedDate value
     * @param string $createdDate
     * @return \StructType\Distributionlist
     */
    public function setCreatedDate($createdDate = null)
    {
        // validation for constraint: string
        if (!is_null($createdDate) && !is_string($createdDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdDate, true), gettype($createdDate)), __LINE__);
        }
        $this->CreatedDate = $createdDate;
        return $this;
    }
    /**
     * Get CreatedTime value
     * @return string|null
     */
    public function getCreatedTime()
    {
        return $this->CreatedTime;
    }
    /**
     * Set CreatedTime value
     * @param string $createdTime
     * @return \StructType\Distributionlist
     */
    public function setCreatedTime($createdTime = null)
    {
        // validation for constraint: string
        if (!is_null($createdTime) && !is_string($createdTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdTime, true), gettype($createdTime)), __LINE__);
        }
        $this->CreatedTime = $createdTime;
        return $this;
    }
    /**
     * Get SendLocationType value
     * @return string|null
     */
    public function getSendLocationType()
    {
        return $this->SendLocationType;
    }
    /**
     * Set SendLocationType value
     * @param string $sendLocationType
     * @return \StructType\Distributionlist
     */
    public function setSendLocationType($sendLocationType = null)
    {
        // validation for constraint: string
        if (!is_null($sendLocationType) && !is_string($sendLocationType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sendLocationType, true), gettype($sendLocationType)), __LINE__);
        }
        $this->SendLocationType = $sendLocationType;
        return $this;
    }
    /**
     * Get Note value
     * @return string|null
     */
    public function getNote()
    {
        return $this->Note;
    }
    /**
     * Set Note value
     * @param string $note
     * @return \StructType\Distributionlist
     */
    public function setNote($note = null)
    {
        // validation for constraint: string
        if (!is_null($note) && !is_string($note)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($note, true), gettype($note)), __LINE__);
        }
        $this->Note = $note;
        return $this;
    }
    /**
     * Get KepOrMailAddress value
     * @return string|null
     */
    public function getKepOrMailAddress()
    {
        return $this->KepOrMailAddress;
    }
    /**
     * Set KepOrMailAddress value
     * @param string $kepOrMailAddress
     * @return \StructType\Distributionlist
     */
    public function setKepOrMailAddress($kepOrMailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($kepOrMailAddress) && !is_string($kepOrMailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kepOrMailAddress, true), gettype($kepOrMailAddress)), __LINE__);
        }
        $this->KepOrMailAddress = $kepOrMailAddress;
        return $this;
    }
    /**
     * Get OutGoType value
     * @return string|null
     */
    public function getOutGoType()
    {
        return $this->OutGoType;
    }
    /**
     * Set OutGoType value
     * @param string $outGoType
     * @return \StructType\Distributionlist
     */
    public function setOutGoType($outGoType = null)
    {
        // validation for constraint: string
        if (!is_null($outGoType) && !is_string($outGoType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outGoType, true), gettype($outGoType)), __LINE__);
        }
        $this->OutGoType = $outGoType;
        return $this;
    }
}
