<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the first needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientBase class (each generated ServiceType class extends this class)
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'http://ebys.oran.org.tr/dysentegrasyon/integrationmanagement/genericservices.asmx?wsdl',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc...
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'http://ebys.oran.org.tr/dysentegrasyon/integrationmanagement/genericservices.asmx?wsdl',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => ClassMap::get(),
);
/**
 * Samples for Give ServiceType
 */
$give = new \ServiceType\Give($options);
$give->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for GiveDocumentTypes operation/method
 */
if ($give->GiveDocumentTypes(new \StructType\GiveDocumentTypes()) !== false) {
    print_r($give->getResult());
} else {
    print_r($give->getLastError());
}
/**
 * Sample call for GiveWorkflowList operation/method
 */
if ($give->GiveWorkflowList(new \StructType\GiveWorkflowList()) !== false) {
    print_r($give->getResult());
} else {
    print_r($give->getLastError());
}
/**
 * Samples for Test ServiceType
 */
$test = new \ServiceType\Test($options);
$test->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for TestAddDocument operation/method
 */
if ($test->TestAddDocument(new \StructType\TestAddDocument()) !== false) {
    print_r($test->getResult());
} else {
    print_r($test->getLastError());
}
/**
 * Samples for Ebys ServiceType
 */
$ebys = new \ServiceType\Ebys($options);
$ebys->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for EbysEvrakIndir operation/method
 */
if ($ebys->EbysEvrakIndir(new \StructType\EbysEvrakIndir()) !== false) {
    print_r($ebys->getResult());
} else {
    print_r($ebys->getLastError());
}
/**
 * Sample call for EbysBelgeOlustur operation/method
 */
if ($ebys->EbysBelgeOlustur(new \StructType\EbysBelgeOlustur()) !== false) {
    print_r($ebys->getResult());
} else {
    print_r($ebys->getLastError());
}
/**
 * Sample call for EbysBelgeSorgula operation/method
 */
if ($ebys->EbysBelgeSorgula(new \StructType\EbysBelgeSorgula()) !== false) {
    print_r($ebys->getResult());
} else {
    print_r($ebys->getLastError());
}
/**
 * Samples for Oran ServiceType
 */
$oran = new \ServiceType\Oran($options);
$oran->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for OranEvrakSorgula operation/method
 */
if ($oran->OranEvrakSorgula(new \StructType\OranEvrakSorgula()) !== false) {
    print_r($oran->getResult());
} else {
    print_r($oran->getLastError());
}
/**
 * Samples for JMOBISE ServiceType
 */
$jMOBISE = new \ServiceType\JMOBISE($options);
$jMOBISE->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for JMOBISEvrakLogSorgula operation/method
 */
if ($jMOBISE->JMOBISEvrakLogSorgula(new \StructType\JMOBISEvrakLogSorgula()) !== false) {
    print_r($jMOBISE->getResult());
} else {
    print_r($jMOBISE->getLastError());
}
/**
 * Sample call for JMOBISEvrakSorgula operation/method
 */
if ($jMOBISE->JMOBISEvrakSorgula(new \StructType\JMOBISEvrakSorgula()) !== false) {
    print_r($jMOBISE->getResult());
} else {
    print_r($jMOBISE->getLastError());
}
/**
 * Samples for JMOBIST ServiceType
 */
$jMOBIST = new \ServiceType\JMOBIST($options);
$jMOBIST->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for JMOBISToEbysBelgeSorgula operation/method
 */
if ($jMOBIST->JMOBISToEbysBelgeSorgula(new \StructType\JMOBISToEbysBelgeSorgula()) !== false) {
    print_r($jMOBIST->getResult());
} else {
    print_r($jMOBIST->getLastError());
}
/**
 * Sample call for JMOBISToEbysBelgeOlustur operation/method
 */
if ($jMOBIST->JMOBISToEbysBelgeOlustur(new \StructType\JMOBISToEbysBelgeOlustur()) !== false) {
    print_r($jMOBIST->getResult());
} else {
    print_r($jMOBIST->getLastError());
}
/**
 * Samples for DEUT ServiceType
 */
$dEUT = new \ServiceType\DEUT($options);
/**
 * Sample call for DEUToEbysBelgeOlustur operation/method
 */
if ($dEUT->DEUToEbysBelgeOlustur(new \StructType\DEUToEbysBelgeOlustur()) !== false) {
    print_r($dEUT->getResult());
} else {
    print_r($dEUT->getLastError());
}
/**
 * Sample call for DEUToEbysBelgeSorgula operation/method
 */
if ($dEUT->DEUToEbysBelgeSorgula(new \StructType\DEUToEbysBelgeSorgula()) !== false) {
    print_r($dEUT->getResult());
} else {
    print_r($dEUT->getLastError());
}
/**
 * Samples for Obs ServiceType
 */
$obs = new \ServiceType\Obs($options);
$obs->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for ObsToEbysBelgeOlustur operation/method
 */
if ($obs->ObsToEbysBelgeOlustur(new \StructType\ObsToEbysBelgeOlustur()) !== false) {
    print_r($obs->getResult());
} else {
    print_r($obs->getLastError());
}
/**
 * Sample call for ObsToEbysBelgeSorgula operation/method
 */
if ($obs->ObsToEbysBelgeSorgula(new \StructType\ObsToEbysBelgeSorgula()) !== false) {
    print_r($obs->getResult());
} else {
    print_r($obs->getLastError());
}
/**
 * Samples for Add ServiceType
 */
$add = new \ServiceType\Add($options);
$add->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for AddDocument operation/method
 */
if ($add->AddDocument(new \StructType\AddDocument()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Sample call for AddDtvtGS operation/method
 */
if ($add->AddDtvtGS(new \StructType\AddDtvtGS()) !== false) {
    print_r($add->getResult());
} else {
    print_r($add->getLastError());
}
/**
 * Samples for Get ServiceType
 */
$get = new \ServiceType\Get($options);
$get->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for GetChairsForUser operation/method
 */
if ($get->GetChairsForUser(new \StructType\GetChairsForUser()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetUsers operation/method
 */
if ($get->GetUsers(new \StructType\GetUsers()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetUnReadDocuments operation/method
 */
if ($get->GetUnReadDocuments(new \StructType\GetUnReadDocuments()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetSignDocuments operation/method
 */
if ($get->GetSignDocuments(new \StructType\GetSignDocuments()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetServiceAndProfileValue operation/method
 */
if ($get->GetServiceAndProfileValue(new \StructType\GetServiceAndProfileValue()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetWebServiceInfo operation/method
 */
if ($get->GetWebServiceInfo(new \StructType\GetWebServiceInfo()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDocumentTypeProfileValuesEC operation/method
 */
if ($get->getDocumentTypeProfileValuesEC(new \StructType\GetDocumentTypeProfileValuesEC()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDocumentTypeProfileValuesPrinter operation/method
 */
if ($get->getDocumentTypeProfileValuesPrinter(new \StructType\GetDocumentTypeProfileValuesPrinter()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getChairID operation/method
 */
if ($get->getChairID(new \StructType\GetChairID()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetUsersChairs operation/method
 */
if ($get->GetUsersChairs(new \StructType\GetUsersChairs()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetServiceUserInfoGS operation/method
 */
if ($get->GetServiceUserInfoGS(new \StructType\GetServiceUserInfoGS()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetDocumentProcessInfoGS operation/method
 */
if ($get->GetDocumentProcessInfoGS(new \StructType\GetDocumentProcessInfoGS()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetSDPlist operation/method
 */
if ($get->GetSDPlist(new \StructType\GetSDPlist()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetPersonelInfoforIncomingGS operation/method
 */
if ($get->GetPersonelInfoforIncomingGS(new \StructType\GetPersonelInfoforIncomingGS()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for View ServiceType
 */
$view = new \ServiceType\View($options);
$view->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for ViewDocument operation/method
 */
if ($view->ViewDocument(new \StructType\ViewDocument()) !== false) {
    print_r($view->getResult());
} else {
    print_r($view->getLastError());
}
/**
 * Sample call for ViewDocumentGS operation/method
 */
if ($view->ViewDocumentGS(new \StructType\ViewDocumentGS()) !== false) {
    print_r($view->getResult());
} else {
    print_r($view->getLastError());
}
/**
 * Samples for Search ServiceType
 */
$search = new \ServiceType\Search($options);
$search->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for SearchChairPrinter operation/method
 */
if ($search->SearchChairPrinter(new \StructType\SearchChairPrinter()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Samples for Save ServiceType
 */
$save = new \ServiceType\Save($options);
$save->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for SaveDynamicWorkFlow operation/method
 */
if ($save->SaveDynamicWorkFlow(new \StructType\SaveDynamicWorkFlow()) !== false) {
    print_r($save->getResult());
} else {
    print_r($save->getLastError());
}
/**
 * Sample call for saveDocumentTypeProfileValues operation/method
 */
if ($save->saveDocumentTypeProfileValues(new \StructType\SaveDocumentTypeProfileValues()) !== false) {
    print_r($save->getResult());
} else {
    print_r($save->getLastError());
}
/**
 * Sample call for saveDocumentTypeProfileValuesPrinter operation/method
 */
if ($save->saveDocumentTypeProfileValuesPrinter(new \StructType\SaveDocumentTypeProfileValuesPrinter()) !== false) {
    print_r($save->getResult());
} else {
    print_r($save->getLastError());
}
/**
 * Sample call for SaveDynamicWorkFlowGS operation/method
 */
if ($save->SaveDynamicWorkFlowGS(new \StructType\SaveDynamicWorkFlowGS()) !== false) {
    print_r($save->getResult());
} else {
    print_r($save->getLastError());
}
/**
 * Sample call for SaveObjectGS operation/method
 */
if ($save->SaveObjectGS(new \StructType\SaveObjectGS()) !== false) {
    print_r($save->getResult());
} else {
    print_r($save->getLastError());
}
/**
 * Samples for Post ServiceType
 */
$post = new \ServiceType\Post($options);
$post->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for PostDocumentDataGS operation/method
 */
if ($post->PostDocumentDataGS(new \StructType\PostDocumentDataGS()) !== false) {
    print_r($post->getResult());
} else {
    print_r($post->getLastError());
}
/**
 * Samples for Load ServiceType
 */
$load = new \ServiceType\Load($options);
$load->setSoapHeaderAuthCredential(new \StructType\AuthCredential());
/**
 * Sample call for LoadEmptyObjectGS operation/method
 */
if ($load->LoadEmptyObjectGS(new \StructType\LoadEmptyObjectGS()) !== false) {
    print_r($load->getResult());
} else {
    print_r($load->getLastError());
}
